----------------------------------------------------------
--			Tables For Random NPC looks
----------------------------------------------------------
MerchantCustomization = {
	BodyTypesMale = {
		{Name = "Male B",Template = "head_male02"},
		{Name = "Male C",Template = "head_male03"},
		{Name = "Male D",Template = "head_male04"},
		{Name = "Male E",Template = "head_male05"},
	},
	BodyTypesFemale = {
		{Name = "Female A",Template = "head_female01"},
		{Name = "Female B",Template = "head_female02"},
		{Name = "Female C",Template = "head_female03"},
		{Name = "Female D",Template = "head_female04"},
	},

	HairTypesMale = {
		{Name = "Regular",Template = "hair_male"},
		{Name = "Bangs",Template = "hair_male_bangs"},
		{Name = "Buzzcut",Template = "hair_male_buzzcut"},
		{Name = "Messy",Template = "hair_male_messy"},
		{Name = "Nobleman",Template = "hair_male_nobleman"},
		{Name = "Roguish",Template = "hair_male_rougish"},
		{Name = "Undercut",Template = "hair_male_undercut"},
		{Name = "Windswept",Template = "hair_male_windswept"},
	},

	HairTypesFemale = {
		{Name = "Pony-Tail A",Template = "hair_female"},
		{Name = "Bob",Template = "hair_female_bob"},
		{Name = "Bun",Template = "hair_female_bun"},
		{Name = "Buzzcut",Template = "hair_female_buzzcut"},
		{Name = "Pigtails",Template = "hair_female_pigtails"},
		{Name = "Pony-Tail B",Template = "hair_female_ponytail"},
		{Name = "Shaggy",Template = "hair_female_shaggy"},
		{Name = "Bald"},
	},

	HairColorTypes = {
		{Name = "Dark Brown", Color = "0xFF554838"},
		{Name = "Brown", Color = "0xFFA56B46"},
		{Name = "Light-Brown", Color = "0xFFA7856A"},
		{Name = "Red", Color = "0xFFB55239"},
		{Name = "Black", Color = "0xFF191919"},
		{Name = "Gray", Color = "0xFFB7A69E"},
		{Name = "Blonde", Color = "0xFFB9B184"},
		{Name = "Dark Red", Color = "0xFF380000"},
		{Name = "Orange", Color = "0xFFFF7F00"},
		{Name = "White", Color = "0xFFFFFFFF"},
	},
}

--=====================================================================
--							CORE FUNCTIONS
--=====================================================================
----------------------------------------------------------
--				HandleModuleAttached()
----------------------------------------------------------
--initializes the merchant
function HandleModuleAttached()
	if(initializer ~= nil) then
		if(initializer.Inventory ~= nil) then
			local coreInventoryList = {}
			for index, inventoryItem in pairs(initializer.Inventory) do
				local stockBuilder = ""
				stockBuilder = stockBuilder .. inventoryItem["Template"] .. ":"
				stockBuilder = stockBuilder .. inventoryItem["DisplayName"] .. ":"
				stockBuilder = stockBuilder .. inventoryItem["Cost"] .. ":"
				stockBuilder = stockBuilder .. inventoryItem["MaxStock"] .. ":"
				stockBuilder = stockBuilder .. inventoryItem["MaxStock"] .. ":"
				stockBuilder = stockBuilder .. inventoryItem["Stackable"] .. ":"
				table.insert(coreInventoryList,stockBuilder)
			end
			this:SetObjVar("current_stock_list",coreInventoryList)
			this:SetObjVar("stock_data_list",coreInventoryList)
		end
		if(initializer.Equipment ~= nil) then
			for index, equipmentItemTable in pairs(initializer.Equipment) do
				HandleEquipmentItem(equipmentItemTable)
			end
		end
		if(initializer.PurchaseList ~= nil) then
			local purchaseList = {}
			for index, inventoryItem in pairs(initializer.PurchaseList) do
				local purchaseBuilder = ""
				purchaseBuilder = purchaseBuilder .. inventoryItem["Template"] .. ":"
				purchaseBuilder = purchaseBuilder .. inventoryItem["DisplayName"] .. ":"
				purchaseBuilder = purchaseBuilder .. inventoryItem["Price"] .. ":"
				purchaseBuilder = purchaseBuilder .. inventoryItem["Stackable"] .. ":"
				table.insert(purchaseList,purchaseBuilder)				
			end
			this:SetObjVar("buy_list",purchaseList)
		else
			this:SetObjVar("buy_list",{})
		end
		if(initializer.DialogText ~= nil) then
			this:SetObjVar("DialogText",initializer.DialogText)
		end
		if(initializer.BuyText ~= nil) then
			this:SetObjVar("BuyText",initializer.BuyText)
		end
		if(initializer.SellText ~= nil) then
			this:SetObjVar("SellText",initializer.SellText)
		end
		if(initializer.RepairText ~= nil) then
			this:SetObjVar("RepairText",initializer.RepairText)
		end
	end
	if not(this:HasObjVar("initialized")) then	
		this:SetObjVar("initialized",true)
		RandomizeLooks()
	end
end

----------------------------------------------------------
--					RandomizeLooks()
----------------------------------------------------------
--randomizes the appearance of the merchant
function RandomizeLooks()
	local rndroll = 1
	if(IsMale(this)) then
		rndroll = math.random(1,4)
		--this:SetAppearanceFromTemplate("playertemplate_male")
		local currentEquipped = this:GetEquippedObject("BodyPartHead")
		--DebugMessage("currentEquipped is "..tostring(currentEquipped))
		if (currentEquipped ~= nil) then
			currentEquipped:Destroy()
		end
		if (MerchantCustomization.BodyTypesMale[rndroll].Template ~= nil) then
			CreateEquippedObj(MerchantCustomization.BodyTypesMale[rndroll].Template, this, "created_body_type")--set the equipped object to the template in the index
		end

		rndroll = math.random(1,8)
		local currentEquipped = this:GetEquippedObject("BodyPartHair")
		if (currentEquipped ~= nil) then
			currentEquipped:Destroy()
		end
		--create the new hair type
		if (MerchantCustomization.HairTypesMale[rndroll].Template ~= nil) then
			CreateEquippedObj(MerchantCustomization.HairTypesMale[rndroll].Template, this, "created_hair")--set the equipped object to the template in the index
		end	
	else
		rndroll = math.random(1,4)
		--this:SetAppearanceFromTemplate("playertemplate_male")
		local currentEquipped = this:GetEquippedObject("BodyPartHead")
		--DebugMessage("currentEquipped is "..tostring(currentEquipped))
		if (currentEquipped ~= nil) then
			currentEquipped:Destroy()
		end
		if (MerchantCustomization.BodyTypesFemale[rndroll].Template ~= nil) then
			CreateEquippedObj(MerchantCustomization.BodyTypesFemale[rndroll].Template, this, "created_body_type")--set the equipped object to the template in the index
		end

		rndroll = math.random(1,8)
		local currentEquipped = this:GetEquippedObject("BodyPartHair")
		if (currentEquipped ~= nil) then
			currentEquipped:Destroy()
		end
		--create the new hair type
		if (MerchantCustomization.HairTypesFemale[rndroll].Template ~= nil) then
			CreateEquippedObj(MerchantCustomization.HairTypesFemale[rndroll].Template, this, "created_hair")--set the equipped object to the template in the index
		end	
	end
end

----------------------------------------------------------
--			HandleEquipmentItem(equipmentItemTable)
----------------------------------------------------------
--if the items are hued on the merchant lets keep it that 
--way
function HandleEquipmentItem(equipmentItemTable)
	local template = equipmentItemTable[1]
	local hue = equipmentItemTable[2] 
	CreateEquippedObj(template, this, "equipItemCreated", hue)
end


--======================================================================
--							EVENT HANDLERS
--======================================================================
----------------------------------------------------------
-- EVENTTYPE - EventType.ModuleAttached 			
----------------------------------------------------------
RegisterSingleEventHandler(EventType.ModuleAttached, GetCurrentModule(), HandleModuleAttached)

----------------------------------------------------------
-- EVENTTYPE - EventType.CreatedObject 
----------------------------------------------------------
RegisterEventHandler(EventType.CreatedObject,"created_hair",
	function(success,objRef)
		objRef:SetHue(MerchantCustomization.HairColorTypes[math.random(1,10)].Color)--set the equipped object to the template in the index
	end)

----------------------------------------------------------
-- EVENTTYPE - EventType.CreatedObject			
----------------------------------------------------------
RegisterEventHandler(EventType.CreatedObject,"equipItemCreated",
	function(success,objRef,hue)
		objRef:SetHue(hue)--set the equipped object to the template in the index
	end)